program Txt2Font;

type
 TFont = array[1..12,0..2] of byte;
 TTxt = array[0..23] of string[12];
const
 Bits : array[0..23] of byte = (0,2,1,3, 4,6,8,10,12,14,16,18,
                                         5,7,9,11,13,15,17,19,
                                20,22,21,23);

var
 Ps, i : Integer;
 Ch : Byte;
 T : Text;
 F : File;
 S : String;
 Font : TFont;
 Txt : TTxt;

Procedure Txt2Fnt(Const Txt: TTxt; Var Font: TFont);
var
 i,j,k: Integer;
 L: Longint;
begin
 FillChar(Font, SizeOf(Font), 0);
 for k := 1 to 12 do
  begin
   L := 0;
    for i := 0 to 23 do
     if Txt[Bits[i]][k] <> ' ' then L := L or (Longint(1) shl i);
    move(L, Font[k,0],3);
  end;
end;

begin
 WriteLn('TXT2FONT font.txt');
 if ParamCount = 0 then Halt;
 Ps := Pos('.', ParamStr(1));
 if Ps = 0 then S := ParamStr(1) + '.FNT'
 else S := copy(ParamStr(1),1, Ps-1) + '.FNT';
 Assign(T,ParamStr(1));
 Reset(T);
 if IOResult <> 0 then Halt;
 Assign(F, S);
 ReWrite(F,1);
 if IOResult <> 0 then Halt;
 Ch := 0;
 while not eof(T) do
  begin
   ReadLn(T, S);
   if Ch >= $20 then Write(Char(Ch),' -', Ch, '       '#13)
   else Write('  -', Ch, '       '#13);
   for i := 23 downto 0 do
   begin
    FillChar(S[1], 12, ' ');
    if not eof(T) then ReadLn(T, S);
    Txt[i][0] := #12;
    Move(S[1],Txt[i][1], 12);
   end;
   Txt2Fnt(Txt, Font);
   BlockWrite(F, Font, SizeOf(Font));
   Inc(Ch);
  end;
 Close(F);
 Close(T);
end.
